diff --git a/.gitattributes b/.gitattributes
index 40a0c231f5..f8335da773 100644
--- a/.gitattributes
+++ b/.gitattributes
@@ -2121,7 +2241,7 @@ cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/conversation/IConversationEna
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacade.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeCacheStrategy.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeConfigurator.java -text
-cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeFieldObservationCacheStrategy.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeFieldUnitCacheStrategy.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeNotSupportedException.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/facade/MethodNotSupportedByDerivedUnitTypeException.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/AbstractCategoricalDescriptionBuilder.java -text
@@ -2172,6 +2292,7 @@ cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/INaturalLanguageTextD
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IOccurrenceService.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPolytomousKeyNodeService.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPolytomousKeyService.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IPreferenceService.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IReferenceService.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IService.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/IStatisticsService.java -text
@@ -2194,10 +2315,12 @@ cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/NaturalLanguageGenera
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/OccurrenceServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/PolytomousKeyNodeServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/PolytomousKeyServiceImpl.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/PreferenceServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ReferenceServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ServiceBase.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/ServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/StatisticsServiceImpl.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxaAndNamesSearchMode.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonNodeServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonServiceImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TermServiceImpl.java -text
@@ -2242,10 +2365,14 @@ cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/AbstractPa
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/DefaultPagerImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/StringLabelPagerImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/CdmMassIndexer.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/DocIdBitSetPrinter.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/DocumentSearchResult.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ICdmMassIndexer.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ILuceneIndexToolProvider.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/ISearchResultBuilder.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneIndexToolProviderImpl.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearch.java -text
+cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneMultiSearchException.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/LuceneSearch.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/QueryFactory.java -text
 cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/SearchResult.java -text
@@ -2276,7 +2403,7 @@ cdmlib-services/src/main/resources/wsdl/LSIDDataServiceSOAPBindings.wsdl -text
 cdmlib-services/src/main/resources/wsdl/LSIDPortTypes.wsdl -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/application/FirstDataInserterTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeCacheStrategyTest.java -text
-cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeFieldObservationCacheStrategyTest.java -text
+cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeFieldUnitCacheStrategyTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/facade/DerivedUnitFacadeTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/ClassificationServiceImplTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/CommonServiceImplTest.java -text
@@ -2286,6 +2413,7 @@ cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/IdentificationKeyGene
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/NameServiceImplTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/NaturalLanguageGeneratorTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/PolytomousKeyServiceImplTest.java -text
+cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/PreferenceServiceImplTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/SecurityTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/SecurityWithTransaction.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/api/service/StatisticsServiceImplTest.java -text
@@ -2311,7 +2439,6 @@ cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestDatabase.java -
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestLocationServiceImpl.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestService.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/TestTaxonFunction.java -text
-cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/function/hibernate.cfg.xml -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/CreateDataTest.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/CreateDataTestNoUnit.java -text
 cdmlib-services/src/test/java/eu/etaxonomy/cdm/test/integration/TermLoaderIntegrationTest.java -text
@@ -2341,7 +2468,9 @@ cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/NameServiceImplT
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/OregonScientificDS6639-DSC_0307-small.jpg -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/OregonScientificDS6639-DSC_0307-small.tif -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/PolytomousKeyServiceImplTest.xml -text
+cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/PreferenceServiceImplTest.xml -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/SecurityTest.xml -text
+cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/TaxonNodeServiceImplTest-indexing.xml -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/TaxonNodeServiceImplTest.xml -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/TaxonServiceImplTest.testDeleteSynonym.xml -text
 cdmlib-services/src/test/resources/eu/etaxonomy/cdm/api/service/TaxonServiceImplTest.testInferredSynonyms.xml -text
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/AbstractStringComparator.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/AbstractStringComparator.java
new file mode 100644
index 0000000000..b0c6b38b91
--- /dev/null
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/AbstractStringComparator.java
@@ -0,0 +1,72 @@
+// $Id$
+/**
+ * Copyright (C) 2009 EDIT
+ * European Distributed Institute of Taxonomy 
+ * http://www.e-taxonomy.eu
+ * 
+ * The contents of this file are subject to the Mozilla Public License Version 1.1
+ * See LICENSE.TXT at the top of this package for the full license terms.
+ */
+package eu.etaxonomy.cdm.common;
+
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.Map;
+import java.util.regex.Pattern;
+
+/**
+ * Abstract Comparator for Strings which allows define substitution rules which
+ * are applied to the String to be compared before the actual comparison takes
+ * place. By this it is e.g. possible to influence the position of objects in sorted lists etc.
+ * <p>
+ * <b>Intended usage</b>: To allow maximum flexibility the property
+ * {@link #setSubstitutionRules(Map)} should be set in the spring application
+ * context.
+ * 
+ * @author a.kohlbecker
+ * @date 24.06.2009
+ */
+public abstract class AbstractStringComparator<T extends Object> implements Comparator<T> {
+
+	protected Map<Pattern, String> substitutionRules = null;
+
+	/**
+	 * Set the private field substitutionRules. The substitutionRules consist of
+	 * a regular expression as key and a string to be prepended as value.
+	 * 
+	 * @param rules
+	 */
+	public void setSubstitutionRules(Map<String, String> substitutionRules) {
+		this.substitutionRules = new HashMap<Pattern, String>(substitutionRules.size());
+		for (String regex : substitutionRules.keySet()) {
+			this.substitutionRules.put(Pattern.compile(regex), substitutionRules.get(regex));
+		}
+
+	}
+
+	/**
+	 * Applies the first matching <code>substitutionRules</code> set by
+	 * {@link #setSubstitutionRules()} to the given String. A rules is applied
+	 * in the following way: If the regular expression matches the given string
+	 * <code>s</code> the String mapped by the regular expression is prepended
+	 * to <code>s</code>.
+	 * 
+	 * @param s
+	 * @return
+	 */
+	protected String applySubstitutionRules(String s) {
+		if (substitutionRules == null) {
+			return s;
+		}
+		StringBuffer sb = new StringBuffer();
+		for (Pattern pattern : substitutionRules.keySet()) {
+			if (pattern.matcher(s).matches()) {
+				sb.append(substitutionRules.get(pattern)).append(s);
+				return sb.toString();
+			}
+
+		}
+		return s;
+	}
+
+}
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/CdmUtils.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/CdmUtils.java
index 8ac5da4600..432022219d 100644
--- a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/CdmUtils.java
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/CdmUtils.java
@@ -29,6 +29,7 @@ import java.util.Map;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
 
+import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 
 /**
@@ -259,6 +260,30 @@ public class CdmUtils {
         String[] strings = {string1, string2};
         return concat(separator, strings);
     }
+    
+	
+	/**
+	 * Returns <code>preferred</code> if not blank, else returns <code>alternative</code>.
+	 * If reverse is <code>true</code> computation is 
+	 * the other way round (<code>alternative</code> if not blank, otherwise <code>preferred</code>).
+	 * @param preferred first string
+	 * @param alternative second string
+	 * @param reverse reverse flag
+	 * @param nzTrim if <code>true</code> the result is trimmed and <code>null</code> values are replaced by empty string.
+	 * @return the preferred string
+	 */
+	static public String getPreferredNonEmptyString(String preferred, String alternative, boolean reverse, boolean nzTrim){
+		String result;
+		if (! reverse){
+			result = StringUtils.isBlank(preferred) ? alternative : preferred;
+		}else{
+			result = StringUtils.isBlank(alternative) ? preferred : alternative;
+		}
+		if (nzTrim){
+			result = Nz(result).trim();
+		}
+		return result;
+	}
 
 
     /** Returns a version of the input where all contiguous
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/DOI.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/DOI.java
new file mode 100644
index 0000000000..8cc278a2e7
--- /dev/null
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/DOI.java
@@ -0,0 +1,233 @@
+/**
+* Copyright (C) 2007 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.common;
+
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+
+import org.apache.commons.lang.StringUtils;
+
+
+/**
+ * A class for handling DOIs (http://www.doi.org).
+ * It offers parsing and formatting functionality as well as validation.
+ * A {@link DOI} object can only be created by syntactic valid input.
+ * It internally stores a doi 2 strings, the first one being the registrant number
+ * (including sub numbers), the second being the suffix.
+ * 
+ * 
+ * @author a.mueller
+ * @created 2013-09-04
+ */
+public final class DOI implements java.io.Serializable{
+	
+	/**
+     * Explicit serialVersionUID for interoperability.
+     */
+	private static final long serialVersionUID = -3871039785359980553L;
+
+	public static final int MAX_LENGTH = 1000;
+
+	/**
+	 * The default public DOI proxy server
+	 */
+	public static final String HTTP_DOI_ORG = "http://doi.org/";
+
+	/**
+	 * The former default public DOI proxy server, still supported but no longer preferred.
+	 * @see #HTTP_DOI_ORG
+	 */
+	public static final String HTTP_OLD_DOI_ORG = "http://dx.doi.org/";
+	
+    private volatile transient int hashCode = -1;	// Zero ==> undefined
+
+	//http://www.doi.org/doi_handbook/2_Numbering.html#2.2.1
+//	prefix + suffix, no defined length, case-insensitive, any printable characters
+
+	
+//********************************* VARIABLES *************************************/	
+	
+	/**
+	 * The directory indicator for DOIs as registered at 
+	 */
+	public static final String DIRECTORY_INDICATOR = "10";
+	private String prefix_registrantCode;
+
+	private String suffix;
+
+// ***************************** FACTORY METHODS ***************************************/
+	
+	public static DOI fromString(String doi) throws IllegalArgumentException{
+		return new DOI(doi);
+	}
+	
+	public static DOI fromRegistrantCodeAndSuffix(String registrantCode, String suffix) throws IllegalArgumentException{
+		return new DOI(registrantCode, suffix);
+	}
+	
+	
+// ******************************* CONSTRUCTOR ************************************/	
+	private DOI(){}; //empty constructor required for JAXB
+	
+	
+    /**
+     * Creates a doi by its registrantCode and its suffix
+     * @param registrantCode the registrant code, the is the part following the directoryIndicator "10." 
+     * 	and preceding the first forward slash (followed by the suffix)
+     * @param suffix the suffix is the part of the DOI following the first forward slash. It is provided 
+     * by the registrant
+     */
+    private DOI(String registrantCode, String suffix) {
+    	//preliminary until prefix_registrantCode and suffix validation is implemented
+		this("10." + registrantCode + "/" + suffix);
+		
+		//use only after validation of both parts
+//		this.prefix_registrantCode = registrantCode;
+//		this.suffix = suffix;
+	}
+
+    private DOI(String doiString) {
+		super();
+		parseDoiString(doiString);
+	}
+
+//************************************ GETTER ***********************************/    
+	
+	public String getPrefix() {
+		return makePrefix();
+	}
+    
+	public String getPrefix_registrantCode() {
+		return prefix_registrantCode;
+	}
+
+	public String getSuffix() {
+		return suffix;
+	}
+
+	private static Pattern doiPattern = Pattern.compile("^doi:\\s*", Pattern.CASE_INSENSITIVE); 
+	
+// ********************************************* PARSER *******************************/
+    
+	private void parseDoiString(String doi){
+		boolean isUrn = false;
+		if (StringUtils.isBlank(doi)){
+			throw new IllegalArgumentException("Doi string must not be null or blank");
+		}
+		doi = doi.trim();
+		if (doi.startsWith("https") ){
+			doi = doi.replaceFirst("https", "http").trim();
+		}
+		Matcher matcher = doiPattern.matcher(doi);
+		if (matcher.find()){
+			doi = matcher.replaceFirst("").trim();
+		}
+
+		
+		//replace URI prefix
+		if (doi.startsWith(HTTP_DOI_ORG)){
+			doi = doi.replaceFirst(HTTP_DOI_ORG,"");
+		}else if (doi.startsWith(HTTP_OLD_DOI_ORG)){
+			doi = doi.replaceFirst(HTTP_OLD_DOI_ORG,"");
+		}
+		
+		
+
+		//handle URN prefix
+		if (doi.startsWith("urn:doi:")){
+			doi = doi.replaceFirst("urn:doi:","");
+			isUrn = true;
+		}
+		
+		
+		//now we should have the pure doi
+		if (doi.length() > MAX_LENGTH){
+			//for persistence reason we currently restrict the length of DOIs to 1000
+			throw new IllegalArgumentException("DOIs may have a maximum length of 1000 in the CDM.");
+		}
+		
+		if (! doi.startsWith("10.")){
+			throw new IllegalArgumentException("DOI not parsable. DOI must start with 10. or an URI or URN prefix ");
+		}
+		doi = doi.substring(3);
+		String sep = isUrn? ":" : "/";
+		
+//		registrant
+		String registrant = doi.split(sep)[0];
+		if (!registrant.matches("[0-9]{2,}(?:[.][0-9]+)*")){   //per definition the number of digits may also be 1, however the lowest known number is 3 so we may be on the safe side here 
+			String message = "Invalid prefix '10.%s'";
+			throw new IllegalArgumentException(String.format(message, registrant));
+		}
+		//suffix
+		String suffix = doi.replaceFirst(registrant + sep,"");
+		if (! suffix.matches("\\p{Print}+")){
+			String message = "Suffix should only include printable characters";
+			throw new IllegalArgumentException(message);
+		}
+		if (isUrn){
+			//TODO do some other replacements according to http://www.doi.org/doi_handbook/2_Numbering.html#2.6.3
+			//e.g. slash becomes : in URN
+			//TODO do we need this also for other URIs? According to http://www.doi.org/doi_handbook/2_Numbering.html#2.6 it is only required for URNs
+			suffix = UrlUtf8Coder.unescape(suffix);
+		}
+		//success
+		this.prefix_registrantCode = registrant;
+		this.suffix = suffix;
+			
+	}
+	
+	
+	private String makePrefix(){
+		return DIRECTORY_INDICATOR + "." + this.prefix_registrantCode;
+	}
+	
+	private String makeDoi(){
+		return makePrefix() + "/" + this.suffix;
+	}
+	
+	public String asURI(){
+		return HTTP_DOI_ORG + makePrefix() + "/" + uriEncodedSuffix();
+	}
+	
+	private String uriEncodedSuffix() {
+		String result = UrlUtf8Coder.encode(this.suffix);
+		return result;
+	}
+
+//************************************************* toString/equals /hashCode *********************/	
+
+	
+	
+	@Override
+	public int hashCode() {
+		if (hashCode == -1) {
+            hashCode = 31 * prefix_registrantCode.toUpperCase().hashCode() + suffix.toUpperCase().hashCode();
+        }
+        return hashCode;
+	}
+
+
+	@Override
+	public boolean equals(Object obj) {
+		if (obj instanceof DOI){
+			DOI doi = (DOI)obj;
+			if (this.prefix_registrantCode.toUpperCase().equals(doi.prefix_registrantCode.toUpperCase()) &&
+					this.suffix.toUpperCase().equals(doi.suffix.toUpperCase())){
+				return true;
+			}
+		}
+		return false;
+	}
+
+
+	@Override
+	public String toString(){
+		return makeDoi();
+	}
+}
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/Tree.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/Tree.java
index 7c4eb2285e..0d93c84962 100644
--- a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/Tree.java
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/Tree.java
@@ -3,7 +3,6 @@ package eu.etaxonomy.cdm.common;
 import java.util.ArrayList;
 import java.util.List;
 
-//import eu.etaxonomy.cdm.model.location.TdwgAreaTest.NamedAreaTree;
 
 public class Tree<T> {
 	 
diff --git a/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UTF8.java b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UTF8.java
new file mode 100644
index 0000000000..549b933acc
--- /dev/null
+++ b/cdmlib-commons/src/main/java/eu/etaxonomy/cdm/common/UTF8.java
@@ -0,0 +1,32 @@
+/**
+ * 
+ */
+package eu.etaxonomy.cdm.common;
+
+/**
+ * This class is a constant holder for commonly used UTF-8 characters.
+ *  
+ * @author a.mueller
+ * @since 19.06.2013
+ */
+public enum UTF8 {
+	
+	
+	EN_DASH("\u2013"),   // https://de.wikipedia.org/wiki/Halbgeviertstrich
+	SPATIUM("\u202F"),   //very short non-breaking space
+	EN_DASH_SPATIUM("\u202F\u2013\u202F"),
+	HYBRID ("\u00D7"),   // hybrid sign
+	SHARP_S("\u00DF"),
+	;
+
+	private String value;
+	
+	private UTF8(String value) {
+		this.value = value;
+	}
+	
+	public String toString(){
+		return value;
+	}
+	
+}
